﻿using System.Collections;
using System.Collections.Generic;
using UnityEditor;
using UnityEngine;

[CustomEditor(typeof(WaveManager))]
public class WaveManagerInspector : Editor
{

    private Vector2 pos;
    private Queue<int> ids = new Queue<int>();

    // Use this for initialization
    public override void OnInspectorGUI()
    {
        pos = EditorGUILayout.Vector2Field("Pos", pos);
        WaveManager manager = (WaveManager)target;

        if (GUILayout.Button("Test Case"))
        {
            ids.Enqueue(manager.Add(new Vector2(35, 35)));
            //ids.Enqueue(manager.Add(new Vector2(5, 4)));
            //ids.Enqueue(manager.Add(new Vector2(20, 2)));
            //ids.Enqueue(manager.Add(new Vector2(1, 14)));
        }

        if (GUILayout.Button("Generate at"))
            manager.Add(pos);


        if (GUILayout.Button("End"))
            manager.End();
        if (GUILayout.Button("Restart"))
            manager.Restart();

        if (GUILayout.Button("Kill oldest"))
            if (ids.Count > 0)
                manager.KillById(ids.Dequeue());


        if (GUILayout.Button("Clear"))
            manager.Reset();


        this.DrawDefaultInspector();
    }

}
