﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public enum GameStates {PLAYING, WIN, PAUSED }

public class GameStateManager : MonoBehaviour {

    public static GameStateManager instance;

    [SerializeField]GameStates currentState;
    GameStates oldState;

    public delegate void GameStateDelegate();
    public GameStateDelegate playing;
    public GameStateDelegate win;
    public GameStateDelegate paused;

    private void Awake()
    {
        if (instance == null) instance = this;
        if (instance != this) Destroy(gameObject);
        //DontDestroyOnLoad(this);
    }

    private void Start()
    {
        currentState = GameStates.PLAYING;
        oldState = currentState;
    }

    private void Update()
    {
        if(currentState != oldState)
        {
            switch (currentState)
            {
                case GameStates.PLAYING:
                    if(playing != null)playing();
                    break;
                case GameStates.WIN:
                    if(win != null)win();
                    break;
                case GameStates.PAUSED:
                    if(paused != null)paused();
                    break;
                default:
                    break;
            }
            oldState = currentState;
        }
    }

    public void SetState(GameStates _state)
    {
        currentState = _state;
    }

    public GameStates GetState()
    {
        return currentState;
    }
}
