﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class InputManager : MonoBehaviour {

    public static InputManager instance;

    [SerializeField]FoamHead p1;
    [SerializeField]FoamHead p2;

    public float p1X;
    public float p1Z;

    public float p2X;
    public float p2Z;

    void Awake()
    {
        if (instance == null) instance = this;
        if (instance != this) Destroy(gameObject);
        //DontDestroyOnLoad(this);
    }

    void Update()
    {
        if(GameStateManager.instance.GetState() == GameStates.PLAYING)
        {
            PlayerOneInput();
            PlayerTwoInuput();

            p1Z = Input.GetAxis("Player1Horizontal");
            p1X = Input.GetAxis("Player1Vertical");
            p1.Move(p1X, -p1Z);


            p2Z = Input.GetAxis("Player2Horizontal");
            p2X = Input.GetAxis("Player2Vertical");
            p2.Move(p2X, -p2Z);
        }

        if(Input.GetKey(KeyCode.Escape))
        {
            GameStateManager.instance.SetState(GameStates.PAUSED);
        }
    }

    void PlayerOneInput()
    {
        if (Input.GetKey(KeyCode.Space))
        {
            p1.PutFHInCoffeMakeWaves();
        }
        else
            p1.MakingWaves = false;
    }

    void PlayerTwoInuput()
    {
        if (Input.GetKey(KeyCode.Minus))
        {
            p2.PutFHInCoffeMakeWaves();
        }
        else
            p2.MakingWaves = false;
    }
}
