﻿using System;
using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class Marshmallow : MonoBehaviour
{
    private Rigidbody rigid;
    [SerializeField] private float speed = 40000;
    private int waveID;

    public void Awake()
    {
        rigid = this.GetComponent<Rigidbody>();
    }

    public void Update()
    {
        rigid.velocity = Vector3.down * Time.deltaTime * speed;
    }


    private void OnTriggerEnter(Collider _other)
    {
        Destroy(this.GetComponent<Collider>());

        speed *= 0.2f;

        float radius = 0.5f;
        waveID = Main.Instance.WaveManager.Add(new Vector2(this.transform.localPosition.x, this.transform.localPosition.z), radius: radius);

        StartCoroutine(Die());
    }

    private IEnumerator Die()
    {
        yield return new WaitForSeconds(2);

        Main.Instance.WaveManager.KillById(waveID);

        Destroy(this.gameObject);
    }
}
