﻿using System;
using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public enum Player {NONE, MARSHMALLOW, COOKIE, COUNT }

public class Trombone : MonoBehaviour {

    [SerializeField]Player player;

    bool canCollide = true;

    float collideCD = 3f;
    float collideCDTimer = 0f;

    private void OnCollisionEnter(Collision _other)
    {
        if(canCollide)
        {
            switch (player)
            {
                case Player.MARSHMALLOW:
                    if (_other.gameObject.tag == "Player1")
                    {
                        Debug.Log("Marshmallow Queen WINS!");
                        GameManager.instance.WinCounter(Player.MARSHMALLOW);
                        StartCoroutine(Restart());
                    }
                    break;
                case Player.COOKIE:
                    if (_other.gameObject.tag == "Player2")
                    {
                        Debug.Log("Cookiemonster WINS!");
                        GameManager.instance.WinCounter(Player.COOKIE);
                        StartCoroutine(Restart());
                    }
                    break;
                default:
                    break;
            }
            canCollide = false;
        }
    }

    private IEnumerator Restart()
    {
        Main.Instance.WaveManager.End();
        yield return new WaitForSeconds(1f);

        Main.Reset();
        Main.Instance.WaveManager.Restart();
    }

    public void OnEnable()
    {
        
    }


    private void Update()
    {
        if(!canCollide)
        {
            collideCDTimer += Time.deltaTime;
            if(collideCDTimer >= collideCD)
            {
                collideCDTimer = 0f;
                canCollide = true;
            }
        }
    }
}
